com.holonplatform.datastore.jpa

## Enum ORMPlatform

- java.lang.Object
- - java.lang.Enum<ORMPlatform>
  - - com.holonplatform.datastore.jpa.ORMPlatform

- All Implemented Interfaces:
    Serializable, Comparable<ORMPlatform>

      public enum ORMPlatform
      extends Enum<ORMPlatform>

  Enumeration of ORM platforms.
  Since:
    5.0.0

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `BATOO`
    `DATANUCLEUS`
    `ECLIPSELINK`
    `HIBERNATE`
    `OPENJPA`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static ORMPlatform` | `detectFromClasspath()` Try to detect ORM platform to use form classpath
    `List<String>` | `getDelegates()` EntitManager delegates class names
    `static ORMPlatform` | `resolve(javax.persistence.EntityManager em)` Determines the ORMPlatform from the given `EntityManager`
    `static ORMPlatform` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static ORMPlatform[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `compareTo, equals, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### HIBERNATE

          public static final ORMPlatform HIBERNATE

    - #### ECLIPSELINK

          public static final ORMPlatform ECLIPSELINK

    - #### OPENJPA

          public static final ORMPlatform OPENJPA

    - #### DATANUCLEUS

          public static final ORMPlatform DATANUCLEUS

    - #### BATOO

          public static final ORMPlatform BATOO

  - ### Method Detail

    - #### values

          public static ORMPlatform[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (ORMPlatform c : ORMPlatform.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static ORMPlatform valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### getDelegates

          public List<String> getDelegates()

      EntitManager delegates class names
      Returns:
        Delegates class names

    - #### detectFromClasspath

          public static ORMPlatform detectFromClasspath()
                                                 throws IllegalStateException

      Try to detect ORM platform to use form classpath
      Returns:
        Detected ORMPlatform, or `null` if not found
      Throws:
        `IllegalStateException` - If more than one ORM provide is found in classpath

    - #### resolve

          public static ORMPlatform resolve(javax.persistence.EntityManager em)

      Determines the ORMPlatform from the given `EntityManager`
      Parameters:
        `em` - EntityManager (must be not null)
      Returns:
        Resolved ORMPlatform. If none of know platforms match, `null` is returned

Copyright © 2017 The Holon Platform. All rights reserved.